import os
from random import shuffle, randint
from guizero import App, Box, Picture, PushButton, Text, MenuBar, Window, TextBox
 
#import emojis
emojis_dir = "emojis"
emojis = [os.path.join(emojis_dir, f) for f in os.listdir(emojis_dir) if os.path.isfile(os.path.join(emojis_dir, f))]
shuffle(emojis)
 
#windows
app = App("Snap!", height=350)
rulewindow = Window(app, title = "Rules", height=200, width=600)
rulewindow.hide()
leaderwindow = Window(app, title = "Leaderboard", height=300)
leaderwindow.hide()
 
#group boxes
game_box = Box(app)
pictures_box = Box(game_box, layout="grid", align="left")
buttons_box = Box(game_box, layout="grid", align="right")
scoreboard = Box(app)
timerboard = Box(app)
 
#variables
buttons = []
pictures = []
result = Text(app, text="___")
bonus = 0
firsttime = True
playerscore = []
 
#countdown timer
def countdown():
    global playerscore
    gameovermsg = "Round over. You scored " + score.value + ", may the next player commence."
    text.value = int(text.value) - 1
    if text.value == "0":
        app.info("Alert",gameovermsg)
        playerscore.append(score.value)
        save_file()
        score.value = "0"
        text.value = "20"
        setup_round()
        result.value = ""
 
#consequences of correct or incorrect matches                
def match_emoji(matched):
    global bonus
    scoreLabel.value = "Score: "
    if matched:
        result.value = "Match!"
        score.value = int(score.value) + 1
        bonus = bonus + 1
        text.value = int(text.value) + 5
        if bonus == 3:
            score.value = int(score.value) + 1
            scoreLabel.value = "*** BONUS ***"
            bonus = 0
        setup_round()
    else:
        result.value = "Wrong."
        score.value = int(score.value) - 1
        bonus = 0
 
#sets up the game board       
def setup_round():
    result.value = ""
    
    for picture in pictures:
        picture.image = emojis.pop()
        
 
    for button in buttons:
        button.image = emojis.pop()
        button.update_command(match_emoji, [False])     
    
    matched_emoji = emojis.pop()
    random_picture = randint(0,8)
    random_button = randint(0,8)
    pictures[random_picture].image = matched_emoji
    buttons[random_button].image = matched_emoji
    buttons[random_button].update_command(match_emoji, [True])
 
#restarts the game board
def gostart():
    global firsttime
    for x in range(0,3):
        for y in range(0,3):
            picture = Picture(pictures_box, grid=[x,y])
            pictures.append(picture)
            button = PushButton(buttons_box, grid=[x,y])
            buttons.append(button)
    bonus = "0"
    score.value = "0"
    text.value = "2"
    if firsttime == True:
        text.repeat(1000, countdown)
        firsttime = False
    startupText.hide()
    setup_round()
    startButton.text="Restart"
 
#quit button  
def exit_app():
    app.destroy()
 
#toggled on/off button instead of having multiple functions for the same thing
def rules():
    if rulewindow.visible == True:
        rulewindow.hide()
    else:
        rulewindow.show(wait=True)
 
def leaderboard():
    if leaderwindow.visible == True:
        leaderwindow.hide()
    else:
        leaderwindow.show(wait=True)
        open_file()
 
def open_file():
    with open("savegame.txt", "r") as f:
        leaderboardScores.value = f.read()
 
def save_file():
    with open("savegame.txt", "w") as f:
        for item in playerscore:
            f.write("Score: %s\n" % item)
 
#menu options (mainly to spawn rules and leaderboard windows)  
menubar = MenuBar(app,
                  toplevel=["File","Multiplayer"],
                  options=[
                      [["Exit",exit_app]],
                      [["Rules",rules],["Leaderboard",leaderboard]]
                      ])
 
#app widgets
text = Text(timerboard, text=20, align="right")
timeLabel = Text(timerboard, text="Time Remaining:", align="left")
startButton = PushButton(app, text="Start", command=gostart)
scoreLabel = Text(scoreboard, text="Score:", align="left")
score = Text(scoreboard, text="0", align="left")
exitButton1 = PushButton(leaderwindow, text="Exit", command=leaderboard)
exitButton2 = PushButton(rulewindow, text="Exit", command=rules)
rulesText = Text(rulewindow, text="The rules are as follows... \n Each player gets 20 seconds to find as many matches as possible. \n Each time you successfully match, you gain an extra 5 seconds on the counter. \n If you click an incorrect match you lose a point. \n When player 1's time runs out, player 2 may begin. \n Press reset at any point to restart the game.")
leaderboardScores = TextBox(leaderwindow, multiline=True, height="fill", width="fill")
startupText = Text(app, text="Read rules the before you begin. \n Click start to begin the countdown timer.")
 
app.display()
